/**
 * }u`II data cutter for VS2015
 *  2015/11/23 RuRuRu
 */

#include <cstdint>
#include <cstdio>
#include <cstdlib>
#include <string>

// read 32bit "big" endian
static uint32_t read_dword_be(uint8_t *_src)
{
	return (_src[3] << 0) + (_src[2] << 8) + (_src[1] << 16) + (_src[0] << 24);
}

int main (int argc, char* argv[])
{
	if (argc <  2) {
		return -2;
	}

	// read source file.
	std::FILE *rfp(nullptr);
	uint8_t *buff(nullptr);
	int buff_size(0);
	try {
		rfp = std::fopen(argv[1], "rb");
		if (rfp == nullptr) {
			throw -1;
		}
		std::fseek(rfp, 0, SEEK_END);
		long rsize = std::ftell(rfp);
		if (rsize == -1L) {
			throw -1;
		}
		buff_size = rsize;
		buff = new uint8_t[rsize];
		if (std::fseek(rfp, 0, SEEK_SET) != 0) {
			std::fclose(rfp);
			throw -1;
		}
		if (std::fread(buff, 1, rsize, rfp) != rsize) {
			std::fclose(rfp);
			throw -1;
		}
	} catch( int ret ) {
		if (rfp) {
			std::fclose(rfp);
		}
		delete[] buff;
		return ret;
	}
	std::fclose(rfp);

	// split filename.
	char basename[_MAX_FNAME];
	_splitpath( argv[1], nullptr, nullptr, basename, nullptr);

	// cut files.
	uint32_t last_address = read_dword_be( buff );
	char ext[5] = {0};
	for (int offset=0; offset < last_address; offset += 4) {
		uint32_t data_start = read_dword_be( buff + offset );
		uint32_t data_size = read_dword_be( buff + offset + 4 ) - data_start;
		if (data_start + data_size > buff_size) {
			break;
		}

		sprintf(ext, ".%03d", offset/4);
		std::string outname = std::string(basename) + std::string(ext);
		printf("%s ofs:%04x size:%04x\n", outname.c_str(), data_start, data_size);
		std::FILE *wfp = std::fopen(outname.c_str(), "wb");
		std::fwrite(&buff[data_start], 1, data_size, wfp);
		std::fclose(wfp);
	}

	delete[] buff;
	return 0;
}

